class_name Promise extends Object

class StateAll:
	signal completed()

static func all(signal_list: Array) -> Array:
	var state := StateAll.new()
	var finished := 0
	var results = Array()
	results.resize(signal_list.size())
	var callbacks = Array()
	callbacks.resize(signal_list.size())
	for i in range(signal_list.size()):
		var callback := func (arg = null):
			results[i] = arg
			finished += 1
			if finished == signal_list.size():
				for j in range(signal_list.size()):
					signal_list[j].disconnect(callbacks[j])
				state.completed.emit()
		callbacks[i] = callback
		signal_list[i].connect(callback)
	await state.completed
	return results

class StateAny:
	signal completed(i: int, Variant)

static func any(signal_list: Array):
	var state := StateAny.new()
	var callbacks = Array()
	callbacks.resize(signal_list.size())
	for i in range(signal_list.size()):
		var callback := func (arg = null):
			for j in range(signal_list.size()):
				signal_list[j].disconnect(callbacks[j])
			state.completed.emit(i, arg)
		callbacks[i] = callback
		signal_list[i].connect(callback)
	return await state.completed
