class_name SelectionsDialog extends AcceptDialog

@export var selections := Array()
@export var values := Array()
@export var show_cancel := false
@export var cancel_button_text := "取消"

var signals := Array()

func _ready() -> void:
	signals.resize(selections.size())
	get_ok_button().visible = false
	for i in range(selections.size()):
		var button = add_button(selections[i])
		signals[i] = button.pressed
	if show_cancel:
		add_cancel_button(cancel_button_text)

func select():
	visible = true
	var i = (await Promise.any([canceled] + signals))[0]
	visible = false
	if i == 0:
		return null
	else:
		return values[i - 1]
