@tool
class_name TLToolButton extends Button

@export var tsize := 20:
	set(value):
		tsize = value
		rescale_size()
var texture = null
@export var ticon: Texture2D:
	set(value):
		ticon = value
		queue_redraw()

func rescale_size() -> void:
	var box := get_theme_stylebox(&"normal")
	custom_minimum_size = Vector2(tsize + box.get_margin(SIDE_LEFT) + box.get_margin(SIDE_RIGHT), box.get_margin(SIDE_TOP) + box.get_margin(SIDE_BOTTOM) + tsize)
	queue_redraw()

func _ready() -> void:
	rescale_size()

func _draw() -> void:
	var box := get_theme_stylebox(&"normal")
	if ticon:
		draw_texture(ticon, box.get_offset(),
			Color.hex(0x81898Dff) if disabled else
				Color.hex(0x22aaffff) if button_pressed else
					Color.hex(0xffffffff) if is_hovered() else
						Color.hex(0xbfcfd7ff)
		)
